# Radiomost

Приложение для организации резервного интернет-вещания радиостанций Европейской медиагруппы

## Системные требования

- 64-разрядная операционная система
- Windows 10 (1809 или позднее)
- Windows Server 2016 standart (или позднее)
- Установленный vc_redist (библиотеки среды выполнения Microsoft C и C++ (MSVC)) Последняя версия с сайта microsoft https://aka.ms/vs/17/release/vc_redist.x64.exe

## Установка

- Распаковать архив. Радиомост предполагает, что может быть запущенно несколько копий приложения на одном компьютере. Каждая копия должна работать в отдельной папке. Поэтому если требуется запустить несколько радиостанций, то необходимо сделать копии распакованного архива.
- Установить vc_redist.x64.exe Желательно скачать свежую версию с сайта microsoft https://aka.ms/vs/17/release/vc_redist.x64.exe или взять из архива. (Была обновлена 08.11.2023) Устанавливать нужно один раз, при обновлении Радиомост повторная установка vc_redist не требуется.
- Внутри каждой папки Радиомост хранит конфиг radiomost.ini. Если у вас была предыдущая версия, то нужно скопировать этот файл в новую, для того чтобы сохранить все настройки.
- Запустить Radiomost.exe

## Changelog

## v1.1.15 10.11.2023

- В интерфейсе отображается средняя громкость за последние 3 секунды, вместо моментальной громкости.

## v1.1.14 08.11.2023

- Исправлено отображение аудио-истчоников на сервере.
- Обновлен README.md и добавлен в архив дистрибутива.
- Исправлено отображение громкости в интерфейсе. На видео с ошибкой выходило за границы верстки.
- Добавлено отслеживание Device failure на уровне библиотеки чтения и проигрывания звука. Логгирование и перезапуск в случае проблем с устройством аудио ввода-вывода.
- Из списку аудио-входов исключены loopback и disabled устройства.

## v1.0.5 04.08.2023

- Исправлен приоритет проигрывания, чтобы два источника не играли одновременно

### v1.0.4 28.07.2023

- Файл для блокировки повторного запуска radiomost.lock в папке с .exe файлом
- Исправлена загрузка источников из конфига
- Добавлена информация об .exe для windows
- Обновлены индикаторы. Убран индикатор пересечения порогового уровня тишины
- При превышении порогового значения громкости для тишины шкала громокости меняет цвет на красный
- Добавлены таймеры формата дни, часы, минуты
- Добавлен лог файл radiomost.log

### v1.0.3 18.07.2023

- Изначальная версия

## Выявленные технические особенности

При использовании icecast потоков важно учитывать их fallback настройки. Не рекомендуется настраивать потоки таким образом, чтобы fallback был настроен на icecast и эти же потоки (основной+fallback) были настроены в станции Радиомост. Поскольку получается двойное резервирование. Если на одном icecast запущен основной и резревный (fallback) потоки, то при их одновременном использовании этих потоков в приложении Радиоплеер нужно быть внимательным. Поскольку icecast переключает "слушателей" (которым является приложение Радиоплеер) с fallback потока обратно на основной поток автоматически. Это настройка регулируется опцией fallback-override. Из-за этого при подключении основного потока к icecast, Радиомост может быть переключен icecast сервером с fallback на основной. Тем самым он будет играть один и тот же поток вместо двух (резервный и основной). С этим мы столкнулись при тестировании.

> fallback-override
> When enabled, this allows a connecting source client or relay on this mountpoint to move listening 
> clients back from the fallback mount.
